﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1
    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    Dim NumCounter As Integer
    Dim Mode As MccDaq.CounterMode
    Dim CounterTickSize As MccDaq.CounterTickSize
    Dim CounterDebounceTime As MccDaq.CounterDebounceTime
    Dim CounterDebounceMode As MccDaq.CounterDebounceMode
    Dim CounterEdgeDetection As MccDaq.CounterEdgeDetection
    Dim mappedChannel As Integer

    Dim MccCounter As MccDaq.CounterRegister
    Dim numSamples As Integer
    Dim SamplingRate As Integer
    Dim CtrOptions As MccDaq.ScanOptions
    Public CTRHandle As IntPtr
    Dim ctrDataArray() As UInteger
    Dim CurIndex As Integer
    Dim CurCount As Integer
    Dim CTRStatus As Short

    Dim lastPass As String


    Dim sngTickSize As Single
    Dim intPeriodMode As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'First,lets make sure there's some kind of USB-1808 plugged in:
        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)
        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No compatible board found in system.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                   " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring


        With cmboTickSize
            .Items.Add("20 nS")
            .Items.Add("200 nS")
            .Items.Add("2000 nS")
            .Items.Add("20,000 nS")
            .SelectedIndex = 1
        End With

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        '1 button to start and stop the scan
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            Me.Refresh()
            Call runEncoder()
        Else
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
            lblModeStatus.Text = "Idle"
            If chkEnableTimer0.Checked = True Then
                ulstat = Daqboard.PulseOutStop(0)
            End If
        End If
    End Sub

    Public Sub runEncoder()
        'Here is where the counter is configured and the scan is launched

        ModeSetup() 'this is called to sort the correct mode value 
        TickSize()  'get the CounterTickSize

        CounterDebounceTime = MccDaq.CounterDebounceTime.DebounceNone
        CounterDebounceMode = MccDaq.CounterDebounceMode.TriggerAfterStable
        CounterEdgeDetection = MccDaq.CounterEdgeDetection.RisingEdge

        mappedChannel = 0
        MccCounter = SelectCounter(nudCounterNumber.Value)
        NumCounter = nudCounterNumber.Value

        ulstat = Daqboard.CConfigScan(MccCounter, Mode, CounterDebounceTime, CounterDebounceMode, _
             CounterEdgeDetection, CounterTickSize, mappedChannel)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        numSamples = Convert.ToInt32(nudNumSamples.Value)
        SamplingRate = Convert.ToInt32(nudSamplingRate.Value)

        'counter options configuration
        CtrOptions = MccDaq.ScanOptions.Background
        If chkContinuous.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.Continuous
        If chkExtClock.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtClock
        If chkExtTrigger.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtTrigger
        If chkHighResRate.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.HighResRate

        'set up sample count and redim arrays
        ReDim ctrDataArray(numSamples / 2 - 1)

        ' set aside memory to hold data
        CTRHandle = MccDaq.MccService.WinBufAlloc32Ex(numSamples)
        If CTRHandle = 0 Then Stop

        ulstat = Daqboard.CInScan(MccCounter, MccCounter, numSamples, SamplingRate, CTRHandle, CtrOptions)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        If ulstat.Value = 0 Then  'if the scan started....
            lblModeStatus.Text = "Running"

            If chkEnableTimer0.Checked Then
                Dim Myfreq As Double = nudTimer0Rate.Value
                Dim MyDutyCycle As Double = 0.5

                ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If
            End If

            'Check the status
            ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If

            lblCurCount.Text = CurCount.ToString()
            lblCurIndex.Text = CurIndex.ToString()

            tmrEncoderCounter.Enabled = True
        Else 'or if timer didn't start.
            lblModeStatus.Text = "Idle"
            Exit Sub
        End If
    End Sub

    Private Sub tmrEncoderCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrEncoderCounter.Tick

        'find out where we are in the scan buffer
        ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        lblCurCount.Text = CurCount.ToString()
        lblCurIndex.Text = CurIndex.ToString()
        If CTRStatus = MccDaq.MccBoard.Running Then lblModeStatus.Text = "Running"

        'At every timer tick, determine if there is new data available. 
        'Figure out where you are in the buffer, 
        'if in the lower half, take the upper half and manipulate the data
        'if in the upper half, take the lower half and manipulate the data
        If CTRHandle = 0 Then Stop

        'Get the latest, new half of the data acquired
        If CurIndex > numSamples / 2 Then      'get the lower half of the buffer
            If lastPass = "Lower" Then Exit Sub 'So we don't replot existing data
            lastPass = "Lower"
            ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, ctrDataArray, 0, CInt(numSamples / 2))
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If

        Else          'get upper half of buffer
            If lastPass = "Upper" Then Exit Sub 'So we don't replot existing data
            lastPass = "Upper"
            ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, ctrDataArray, CInt(numSamples / 2), CInt(numSamples / 2))
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If

        'Display the data.  I'm displaying the #1 element in the array.
        'this is the part you will changed to suit your needs.
        lblPeriod.Text = (ctrDataArray(1) * sngTickSize / intPeriodMode).ToString + " sec"
        lblFreq.Text = (1 / (ctrDataArray(1) * sngTickSize / intPeriodMode)).ToString + " Hz"


        'after each pass of data manipulation, check to see if the scan is still running.
        'If it is, then skip this part, if it is not running any longer 
        'here is a routine to stop the scan, free the buffer, etc.
        If (CTRStatus = MccDaq.MccBoard.Idle) Then
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AiFunction)
            lblModeStatus.Text = "Idle"
            ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
            ulstat = Daqboard.PulseOutStop(0)
        End If
    End Sub

    Public Sub ModeSetup()
        'this routine is used to sort out the mode settings from the forms available options.
        Mode = 0
        Mode = MccDaq.CounterMode.Period
        If (rbuPeriodModeX1.Checked) Then
            Mode = Mode + MccDaq.CounterMode.PeriodModeX1
            intPeriodMode = 1
        ElseIf rbuPeriodModeX10.Checked Then
            Mode = Mode + MccDaq.CounterMode.PeriodModeX10
            intPeriodMode = 10
        ElseIf rbuPeriodModeX100.Checked Then
            Mode = Mode + MccDaq.CounterMode.PeriodModeX100
            intPeriodMode = 100
        ElseIf rbuPeriodModeX1000.Checked Then
            Mode = Mode + MccDaq.CounterMode.PeriodModeX1000
            intPeriodMode = 1000
        End If
    End Sub

    Public Sub TickSize()
        Select Case cmboTickSize.SelectedIndex
            Case 0
                CounterTickSize = MccDaq.CounterTickSize.Tick20ns
                sngTickSize = 0.00000002
            Case 1
                CounterTickSize = MccDaq.CounterTickSize.Tick200ns
                sngTickSize = 0.0000002
            Case 2
                CounterTickSize = MccDaq.CounterTickSize.Tick2000ns
                sngTickSize = 0.000002
            Case 3
                CounterTickSize = MccDaq.CounterTickSize.Tick20000ns
                sngTickSize = 0.00002
        End Select
    End Sub

    Public Function SelectCounter(ByVal nudCounterNumValue As Int32) As Int32
        'selects the counter, and converts the number back to the enumerated MccDaq Counter reg type.
        Select Case nudCounterNumValue
            Case 0
                MccCounter = Convert.ToInt32([Enum].Parse(GetType(MccDaq.Range), MccDaq.CounterRegister.LoadReg0))
            Case 1
                MccCounter = Convert.ToInt32([Enum].Parse(GetType(MccDaq.Range), MccDaq.CounterRegister.LoadReg1))
        End Select

        Return MccCounter
    End Function

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler, that gracefully stops the scan 
        'and returns the program to a stable state.
        tmrEncoderCounter.Enabled = False
        MessageBox.Show(ulstat.Message, "Universal Library Error ", _
                   MessageBoxButtons.OK, MessageBoxIcon.Error)
        lblModeStatus.Text = "Idle"
        btnStartStop.Text = "Start"
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
        ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
        ulstat = Daqboard.PulseOutStop(0)
    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        'ends the program.
        tmrEncoderCounter.Enabled = False
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
        ulstat = Daqboard.PulseOutStop(0)
        lblModeStatus.Text = "Idle"
        End
    End Sub

    '******************************************************************************************************************
    '*Everything from here down is used to control how the program enables and disables features selected by you when *
    '*you run the program, or when you right click on a radio button or any CInScan option.                           *
    '*You can ignore everything from here down, unless you want to see how I created the pop up help, etc.            *
    '******************************************************************************************************************

    Private Sub rbuPeriodModeX1_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles rbuPeriodModeX1000.MouseDown, rbuPeriodModeX100.MouseDown, rbuPeriodModeX10.MouseDown, rbuPeriodModeX1.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CConfigScan() PeriodModeX option:" + _
           vbCrLf + _
           vbCrLf + "PeriodModeX1:  The measurement is latched each time one complete period is observed." + _
            vbCrLf + _
                vbCrLf + "PeriodModeX10:  The measurement is latched each time 10 complete periods are observed." + _
                vbCrLf + _
                vbCrLf + "PeriodModeX100:  The measurement is latched each time 100 complete periods are observed." + _
                vbCrLf + _
                vbCrLf + "PeriodModeX1000:  The measurement is latched each time 1000 complete periods are observed."
            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub lblTickSize_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles lblTickSize.MouseDown, cmboTickSize.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CConfigScan() Ticksize option:" + _
           vbCrLf + _
           vbCrLf + "Sets the tick size, which is the fundamental unit of time for period, pulsewidth, and timing measurements. All of the tickSize settings are MccDaq.CounterTickSize enumerated constants. Set it to one of the constants:" + _
            vbCrLf + _
                vbCrLf + "Tick20ns:  Sets the counter channel's tick size to 20 ns." + _
                vbCrLf + _
                vbCrLf + "Tick200ns:  Sets the counter channel's tick size to 200 ns." + _
                vbCrLf + _
                vbCrLf + "Tick2000ns:  Sets the counter channel's tick size to 2000 ns." + _
                vbCrLf + _
                vbCrLf + "Tick20000ns:  Sets the counter channel's tick size to 20,000 ns."
            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub chkExtClock_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles chkExtClock.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CinScan() External Clock option:" + _
            vbCrLf + _
            vbCrLf +
            "If this option is specified, conversions will be controlled by the signal on the external clock input rather than by the internal pacer clock." + _
            " Each conversion will be triggered on the appropriate edge of the clock input signal (refer to board-specific information in the UL User's Guide). " + _
            "When this option is used the rate parameter is ignored. The sampling rate is dependent on the clock signal. Options for the board will default to a " + _
            "transfer mode that will allow the maximum conversion rate to be attained unless otherwise specified."

            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub chkExtTrigger_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles chkExtTrigger.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CinScan() External Trigger option:" + _
            vbCrLf + _
            vbCrLf +
            "If this option is specified, sampling does not begin until the trigger condition is met. You can set the trigger condition to rising edge, falling edge, or the level of the digital trigger input with the SetTrigger() method. Refer to board-specific information in the UL User's Guide." + _
            vbCrLf + _
            vbCrLf + _
            "To complete the set up of this option, you would need to provide a signal on the External Trigger Input or XTRIG terminal.  As SetTrigger is not implemented in this program, XTRIG requires a rising edge."

            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub chkHighResRate_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles chkHighResRate.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CinScan() High Resolution Rate option:" + _
            vbCrLf + _
            vbCrLf +
            "Acquires data at a high resolution rate. When specified, the rate at which samples are acquired is in 'samples per 1000 seconds per channel'. When this option is not specified, the rate at which samples are acquired is in 'samples per second per channel' (refer to the rate parameter of CInScan in the ULHELP)."

            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub chkContinuous_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles chkContinuous.MouseDown
        Dim MouseArgs As MouseEventArgs = e
        If MouseArgs.Button = Windows.Forms.MouseButtons.Right Then
            HelpInfo.txtHelpInfo.Text = "CinScan() Continuous scan options:" + _
            vbCrLf + _
            vbCrLf +
            "This option puts the function in an endless loop. Once it collects the required number of samples, it resets to the start of the buffer and begins again. The only way to stop this operation is by using StopBackground() with CtrFunction in the FunctionType argument. You can only use this option with Background so that you remain in control of the program." + _
            vbCrLf + _
            vbCrLf + _
            "By design, this program operates in Background mode.  All other options can be selected."

            HelpInfo.Show(Me)
        End If
    End Sub

    Private Sub nudTimer0Rate_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudTimer0Rate.ValueChanged
        If (chkEnableTimer0.Checked And btnStartStop.Text = "Stop") Then
            Dim Myfreq As Double = nudTimer0Rate.Value
            Dim MyDutyCycle As Double = 0.5

            ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If
    End Sub

    Private Sub chkEnableTimer0_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkEnableTimer0.CheckedChanged
        If chkEnableTimer0.Checked = False Then
            ulstat = Daqboard.PulseOutStop(0)
        End If
    End Sub
End Class
