﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1
    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    ' Dim NumCounter As Integer
    Dim Mode As MccDaq.CounterMode
    Dim CounterTickSize As MccDaq.CounterTickSize
    Dim CounterDebounceTime As MccDaq.CounterDebounceTime
    Dim CounterDebounceMode As MccDaq.CounterDebounceMode
    Dim CounterEdgeDetection As MccDaq.CounterEdgeDetection
    Dim mappedChannel As Integer

    Dim MccCounter As MccDaq.CounterRegister
    Dim numSamples As Integer
    Dim MySamples As Integer
    Dim SamplingRate As Integer
    Dim CtrOptions As MccDaq.ScanOptions
    Public CTRHandle As IntPtr
    Dim ctrDataArray() As UInteger
    Dim CurIndex As Integer
    Dim CurCount As Integer
    Dim CTRStatus As Short


    Dim lastPass As String = "Upper"
    Dim sngTickSize As Single
    Dim intPulseWidthMode As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'First,lets make sure there's some kind of 1808 plugged in:
        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)
        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No compatible board found in system.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                   " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring

        With cmboTickSize
            .Items.Add("20 nS")
            .Items.Add("200 nS")
            .Items.Add("2000 nS")
            .Items.Add("20,000 nS")
            .SelectedIndex = 1
        End With

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click

        '1 button to start and stop the scan
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            Me.Refresh()
            lastPass = "Upper"
            Call runCounter()
        Else
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
            lblModeStatus.Text = "Idle"
            If chkEnableTimer0.Checked = True Then
                ulstat = Daqboard.PulseOutStop(0)
            End If
        End If

    End Sub

    Public Sub runCounter()
        'Here is where the counters are configured and the scan is launched

        Mode = MccDaq.CounterMode.PulseWidth
        TickSize()  'get the CounterTickSize

        CounterDebounceTime = MccDaq.CounterDebounceTime.DebounceNone
        CounterDebounceMode = MccDaq.CounterDebounceMode.TriggerAfterStable
        CounterEdgeDetection = MccDaq.CounterEdgeDetection.RisingEdge

        mappedChannel = 0
        MccCounter = SelectCounter(nudCounterNumber.Value)

        ulstat = Daqboard.CConfigScan(MccCounter, Mode, CounterDebounceTime, CounterDebounceMode, _
             CounterEdgeDetection, CounterTickSize, mappedChannel)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        numSamples = Convert.ToInt32(nudNumSamples.Value)
        Dim ScanSamples As Integer = numSamples
        SamplingRate = Convert.ToInt32(nudSamplingRate.Value)

        'counter options configuration
        CtrOptions = MccDaq.ScanOptions.Background
        If chkContinuous.Checked Then
            CtrOptions = CtrOptions + MccDaq.ScanOptions.Continuous
            ScanSamples *= 2
        End If

        If chkExtClock.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtClock
        If chkExtTrigger.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtTrigger
        If chkHighResRate.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.HighResRate

        'set up sample count and redim arrays
        ReDim ctrDataArray(numSamples - 1)


        ' set aside memory to hold data
        CTRHandle = MccDaq.MccService.WinBufAlloc32Ex(ScanSamples)
        If CTRHandle = 0 Then Stop

        ulstat = Daqboard.CInScan(MccCounter, MccCounter, ScanSamples, SamplingRate, CTRHandle, CtrOptions)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        If ulstat.Value = 0 Then  'if the scan started....
            lblModeStatus.Text = "Running"

            If chkEnableTimer0.Checked Then
                Dim Myfreq As Double = nudTimer0Rate.Value
                Dim MyDutyCycle As Double = 0.5

                ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If
            End If

            'Check the status
            ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If

            lblCurCount.Text = CurCount.ToString()
            lblCurIndex.Text = CurIndex.ToString()

            tmrEncoderCounter.Enabled = True
        Else 'or if timer didn't start.
            lblModeStatus.Text = "Idle"
            Exit Sub
        End If
    End Sub

    Private Sub tmrEncoderCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrEncoderCounter.Tick

        'find out where we are in the scan buffer
        ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        lblCurCount.Text = CurCount.ToString()
        lblCurIndex.Text = CurIndex.ToString()
        If CTRStatus = MccDaq.MccBoard.Running Then lblModeStatus.Text = "Running"

        'at every timer tick, determine if there is new data available. 
        'Need to figure out where you are in the buffer, 
        'if in the lower half, take the upper half and manipulate the data
        'if in the upper half, take the lower half and manipulate the data

        If chkContinuous.Checked = True Then
            'Get the latest, new half of the data acquired
            If CurIndex > numSamples Then      'get the lower half of the buffer
                If lastPass = "Lower" Then Exit Sub 'So we don't replot existing data
                lastPass = "Lower"
                ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, ctrDataArray, 0, numSamples)
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If

            Else          'get upper half of buffer
                If lastPass = "Upper" Or lastPass = "" Then Exit Sub 'So we don't replot existing data
                lastPass = "Upper"
                ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, ctrDataArray, numSamples, numSamples)
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If
            End If

            'Using the first element in the array, we can calculate the Pulse width
            lblPulseWidthCalculation.Text = "Pulse Width = " + ctrDataArray(0).ToString + " X " + sngTickSize.ToString
            lblPulseWidthValue.Text = (ctrDataArray(0) * sngTickSize).ToString() + " Seconds"

        Else
            If CurCount = numSamples Then      'get the lower half of the buffer
                ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, ctrDataArray, 0, numSamples)
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If
            End If
            End If

            ListBox1.Items.Clear()
            For x = 0 To numSamples - 1
                ListBox1.Items.Add(ctrDataArray(x))
            Next

            'after each pass of data manipulation, check to see if the scan is still running.
            'If it is, then skip this part, if it is not running any longer,
            'here is a routine to stop the scan, free the buffer, etc.
            If (CTRStatus = MccDaq.MccBoard.Idle) Then
                btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
                ulstat = Daqboard.StopBackground(MccDaq.FunctionType.AiFunction)
                lblModeStatus.Text = "Idle"
                ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
                If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                    errhandler(ulstat)
                    Exit Sub
                End If
            End If

    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        'ends the program.

        End
    End Sub

    Public Sub TickSize()
        Select Case cmboTickSize.SelectedIndex
            Case 0
                CounterTickSize = MccDaq.CounterTickSize.Tick20ns
                sngTickSize = 0.00000002
            Case 1
                CounterTickSize = MccDaq.CounterTickSize.Tick200ns
                sngTickSize = 0.0000002
            Case 2
                CounterTickSize = MccDaq.CounterTickSize.Tick2000ns
                sngTickSize = 0.000002
            Case 3
                CounterTickSize = MccDaq.CounterTickSize.Tick20000ns
                sngTickSize = 0.00002
        End Select
    End Sub

    Public Function SelectCounter(ByVal nudCounterNumValue As Int32) As Int32
        Select Case nudCounterNumValue
            Case 0
                MccCounter = MccDaq.CounterRegister.LoadReg0
            Case 1
                MccCounter = MccDaq.CounterRegister.LoadReg1
        End Select

        Return MccCounter
    End Function

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler, that gracefully stops the scan 
        'and returns the program to a stable state.
        tmrEncoderCounter.Enabled = False
        MessageBox.Show(ulstat.Message, "Universal Library Error ",  MessageBoxButtons.OK, MessageBoxIcon.Error)
        lblModeStatus.Text = "Idle"
        btnStartStop.Text = "Start"
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
        ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
    End Sub

    Private Sub chkEnableTimer0_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkEnableTimer0.CheckedChanged
        If chkEnableTimer0.Checked = False Then
            ulstat = Daqboard.PulseOutStop(0)
        Else
            Dim Myfreq As Double = nudTimer0Rate.Value
            Dim MyDutyCycle As Double = 0.5
            ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
        End If
    End Sub

    Private Sub nudTimer0Rate_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudTimer0Rate.ValueChanged
        If (chkEnableTimer0.Checked And btnStartStop.Text = "Stop") Then
            Dim Myfreq As Double = nudTimer0Rate.Value
            Dim MyDutyCycle As Double = 0.5

            ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If
    End Sub
End Class
