﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1

    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    Dim NumCounter As Integer
    Dim Mode As MccDaq.CounterMode
    Dim CounterDebounceTime As MccDaq.CounterDebounceTime
    Dim CounterDebounceMode As MccDaq.CounterDebounceMode
    Dim CounterEdgeDetection As MccDaq.CounterEdgeDetection
    Dim myCounterTickSize As MccDaq.CounterTickSize

    'this parameter is not used with the USB-1808/X
    'but it is required by CConfigScan()
    'so set it here and forget about it.
    Dim mappedChannel As Integer = 0

    Dim MccCounter As MccDaq.CounterRegister
    Dim numSamples As Integer
    Dim SamplingRate As Integer
    Dim CtrOptions As MccDaq.ScanOptions
    Public CTRHandle As IntPtr
    Dim i32DataArray() As System.Int32
    Dim CurIndex As Integer
    Dim CurCount As Integer
    Dim CTRStatus As Short

    Dim lastPass As String
    Dim j As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'First, let's find out if there is a USB-1808 installed
        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)

        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No compatible device found in system.  Please run InstaCal.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                   " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring


        With cmboDebounce
            .Items.Add("Debounce500ns")
            .Items.Add("Debounce1500ns")
            .Items.Add("Debounce3500ns")
            .Items.Add("Debounce7500ns")
            .Items.Add("Debounce15500ns")
            .Items.Add("Debounce31500ns")
            .Items.Add("Debounce63500ns")
            .Items.Add("Debounce127500ns")
            .Items.Add("Debounce100us")
            .Items.Add("Debounce300us")
            .Items.Add("Debounce700us")
            .Items.Add("Debounce1500us")
            .Items.Add("Debounce3100us")
            .Items.Add("Debounce6300us")
            .Items.Add("Debounce12700us")
            .Items.Add("Debounce25500us")
            .Items.Add("DebounceNone")
            .SelectedIndex = 16
        End With

    End Sub

    Public Sub runCounter()
        'Here is where the counters are configured and the scan is launched
        Mode = MccDaq.CounterMode.Totalize 'Totalizer mode

        Select Case (cmboDebounce.SelectedIndex)
            Case 0
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce500ns
            Case 1
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce1500ns
            Case 2
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce3500ns
            Case 3
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce7500ns
            Case 4
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce15500ns
            Case 5
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce31500ns
            Case 6
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce63500ns
            Case 7
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce127500ns
            Case 8
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce100us
            Case 9
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce300us
            Case 10
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce700us
            Case 11
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce1500ns
            Case 12
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce3100us
            Case 13
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce6300us
            Case 14
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce12700us
            Case 15
                CounterDebounceTime = MccDaq.CounterDebounceTime.Debounce25500us
            Case 16
                CounterDebounceTime = MccDaq.CounterDebounceTime.DebounceNone
        End Select

        CounterDebounceMode = MccDaq.CounterDebounceMode.TriggerAfterStable
        CounterEdgeDetection = MccDaq.CounterEdgeDetection.RisingEdge
        myCounterTickSize = MccDaq.CounterTickSize.Tick20pt83ns

        MccCounter = SelectCounter(nudCounterNumber.Value)
        NumCounter = nudCounterNumber.Value

        ulstat = Daqboard.CConfigScan(MccCounter, Mode, CounterDebounceTime, CounterDebounceMode, _
             CounterEdgeDetection, myCounterTickSize, mappedChannel)

        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If
       

        numSamples = Convert.ToInt32(nudNumSamples.Value)
        SamplingRate = Convert.ToInt32(nudSamplingRate.Value)

        'counter options configuration
        CtrOptions = MccDaq.ScanOptions.Background
        If chkContinuous.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.Continuous
        If chkExtClock.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtClock
        If chkExtTrigger.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.ExtTrigger
        If chkHighResRate.Checked Then CtrOptions = CtrOptions + MccDaq.ScanOptions.HighResRate


        CtrOptions = CtrOptions + MccDaq.ScanOptions.Ctr32Bit
        ReDim i32DataArray(numSamples)
        CTRHandle = MccDaq.MccService.WinBufAlloc32Ex(numSamples * 2)

        If CTRHandle = IntPtr.Zero Then
            MessageBox.Show("Handle not created", "Bad Handle", _
                  MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        ulstat = Daqboard.CInScan(MccCounter, MccCounter, numSamples * 2, SamplingRate, CTRHandle, CtrOptions)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            lblModeStatus.Text = "Idle"
            errhandler(ulstat)
            Exit Sub
        Else
            lblModeStatus.Text = "Running"
        End If


        'Check the status
        ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        lblCurCount.Text = CurCount.ToString()
        lblCurIndex.Text = CurIndex.ToString()

        tmrEncoderCounter.Enabled = True

    End Sub

    Public Function SelectCounter(ByVal nudCounterNumValue As Int32) As Int32
        Select Case nudCounterNumValue
            Case 0
                MccCounter = MccDaq.CounterRegister.LoadReg0
            Case 1
                MccCounter = MccDaq.CounterRegister.LoadReg1
        End Select

        Return MccCounter
    End Function

    Private Sub tmrEncoderCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrEncoderCounter.Tick

        'find out where we are in the scan buffer
        ulstat = Daqboard.GetStatus(CTRStatus, CurCount, CurIndex, MccDaq.FunctionType.CtrFunction)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        lblCurCount.Text = CurCount.ToString()
        lblCurIndex.Text = CurIndex.ToString()
        If CTRStatus = MccDaq.MccBoard.Running Then lblModeStatus.Text = "Running"

        'at every timer tick, determine if there is new data available. 
        'Need to figure out where you are in the buffer, 
        'if in the lower half, take the upper half and manipulate the data
        'if in the upper half, take the lower half and manipulate the data
        'Here the data is plotted in a graph, and displayed in the list box.
        If CTRHandle = 0 Then Stop

        'Get the latest, new half of the data acquired
        If CurIndex > numSamples Then      'get the lower half of the buffer
            If lastPass = "Lower" Then Exit Sub 'So we don't replot existing data
            lastPass = "Lower"
            ListBox1.Items.Clear()
            ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, i32DataArray, 0, numSamples)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If

        Else          'get upper half of buffer
            If lastPass = "Upper" Then Exit Sub 'So we don't replot existing data
            lastPass = "Upper"
            ListBox1.Items.Clear()
            ulstat = MccDaq.MccService.WinBufToArray32(CTRHandle, i32DataArray, numSamples, numSamples)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If

        'this is the part you will changed to suit your needs.
        'Here we list the data in a listbox.....

        For Me.j = 0 To 50
            ListBox1.Items.Add(i32DataArray(j))

        Next

        'after each pass of data manipulation, check to see if the scan is still running.
        'If it is, then skip this part, if it is not running any longer then
        'here is a routine to stop the scan, free the buffer, etc.
        If (CTRStatus = MccDaq.MccBoard.Idle) Then
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
            lblModeStatus.Text = "Idle"
            ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If

    End Sub

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler, that gracefully stops the scan 
        'and returns the program to a stable state.
        tmrEncoderCounter.Enabled = False
        MessageBox.Show(ulstat.Message, "Universal Library Error ", MessageBoxButtons.OK, MessageBoxIcon.Error)
        lblModeStatus.Text = "Idle"
        btnStartStop.Text = "Start"
        ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction)
        ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        '1 button to start and stop the scan
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            ListBox1.Items.Clear()
            Me.Refresh()
            Call runCounter()
        Else
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            ulstat = Daqboard.StopBackground(MccDaq.FunctionType.CtrFunction) 'Stop the counting operation
            ulstat = MccDaq.MccService.WinBufFreeEx(CTRHandle) ' Free up memory for use by other programs
            lblModeStatus.Text = "Idle"
        End If
    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        'ends the program.

        End

    End Sub
End Class
