﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1

    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    Dim Mode As MccDaq.CounterMode
    Dim CounterDebounceTime As MccDaq.CounterDebounceTime
    Dim CounterDebounceMode As MccDaq.CounterDebounceMode
    Dim CounterEdgeDetection As MccDaq.CounterEdgeDetection
    Dim myCounterTickSize As MccDaq.CounterTickSize
    Dim mappedChannel As Integer
    Dim MyCount As UInteger
    Dim MccCounter As MccDaq.CounterRegister

    Const DontCare As Integer = 0

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)

        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No compatible board found in system.  Please run InstaCal.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                  " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            Me.Refresh()
            Call runTotalizer()
        Else
            btnStartStop.Text = "Start"
            tmrCounter.Enabled = False
            lblModeStatus.Text = "Idle"
        End If

    End Sub
    Public Sub runTotalizer()

        'Configure Mode + Option and all other parameters:
        Mode = 0 'totalize
        If chkClearOnRead.Checked Then Mode += MccDaq.CounterMode.ClearOnRead

        CounterDebounceTime = MccDaq.CounterDebounceTime.DebounceNone
        CounterDebounceMode = MccDaq.CounterDebounceMode.TriggerAfterStable
        CounterEdgeDetection = MccDaq.CounterEdgeDetection.RisingEdge
        myCounterTickSize = MccDaq.CounterTickSize.Tick20pt83ns
        mappedChannel = DontCare

        MccCounter = SelectCounter(nudCounterNumber.Value)

        'Call CConfigScan to configure the scan with selected features and options:
        ulstat = Daqboard.CConfigScan(MccCounter, Mode, CounterDebounceTime, CounterDebounceMode, _
             CounterEdgeDetection, myCounterTickSize, mappedChannel)
        lblULSTatus.Text = "UL Status: " + ulstat.Message

        If ulstat.Value = 0 Then
            lblModeStatus.Text = "Running"
            tmrCounter.Enabled = True
        Else
            lblModeStatus.Text = "Idle"
            btnStartStop.Text = "Start"
            Exit Sub
        End If

        'Clear counter so app will always start at 0
        'disable this line if you want to see it count 
        'in the other direction after restart.
        ulstat = Daqboard.CLoad32(MccCounter, 0)

        tmrCounter.Enabled = True

    End Sub

    Public Function SelectCounter(ByVal nudCounterNumValue As Int32) As Int32
        'Select the counter:
        Select Case nudCounterNumValue
            Case 0
                MccCounter = MccDaq.CounterRegister.LoadReg0
            Case 1
                MccCounter = MccDaq.CounterRegister.LoadReg1
        End Select

        Return MccCounter

    End Function

    Private Sub tmrEncoderCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrCounter.Tick
        'Read the counter and display the value read.
        ulstat = Daqboard.CIn32(MccCounter, MyCount)
        lblCounterValueRead.Text = MyCount
    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        'stop the timer and end the program.
        tmrCounter.Enabled = False
        End
    End Sub

End Class
