﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1

    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    Dim Mode As MccDaq.CounterMode
    Dim CounterDebounceTime As MccDaq.CounterDebounceTime
    Dim CounterDebounceMode As MccDaq.CounterDebounceMode
    Dim CounterEdgeDetection As MccDaq.CounterEdgeDetection
    Dim myCounterTickSize As MccDaq.CounterTickSize
    Dim mappedChannel As Integer
    Dim MyCount As UInteger
    Dim MccCounter As MccDaq.CounterRegister
    Dim MaxLimitRegister As MccDaq.CounterRegister

    Const DontCare As Integer = 0

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)

        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If


        If Boardfound = False Then
            MsgBox("No compatible board found in system.  Please run InstaCal.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                  " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            Me.Refresh()
            Call runTotalizer()
        Else
            btnStartStop.Text = "Start"
            tmrEncoderCounter.Enabled = False
            lblModeStatus.Text = "Idle"
        End If

    End Sub
    Public Sub runTotalizer()

        'Configure Mode + Option and all other parameters:
        Mode = 0 'totalize
        If chkRangeLimitOn.Checked Then Mode += MccDaq.CounterMode.RangeLimitOn '
        ulstat = Daqboard.CLoad(MaxLimitRegister, Convert.ToInt16(txtMaxLimitRegValue.Text))
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        CounterDebounceTime = MccDaq.CounterDebounceTime.DebounceNone
        CounterDebounceMode = MccDaq.CounterDebounceMode.TriggerAfterStable
        CounterEdgeDetection = MccDaq.CounterEdgeDetection.RisingEdge
        myCounterTickSize = MccDaq.CounterTickSize.Tick20pt83ns
        mappedChannel = DontCare

        MccCounter = SelectCounter(nudCounterNumber.Value)

        'Call CConfigScan to configure the scan with selected features and options:
        ulstat = Daqboard.CConfigScan(MccCounter, Mode, CounterDebounceTime, CounterDebounceMode, _
             CounterEdgeDetection, myCounterTickSize, mappedChannel)
        If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
            errhandler(ulstat)
            Exit Sub
        End If

        If ulstat.Value = 0 Then
            lblModeStatus.Text = "Running"
            tmrEncoderCounter.Enabled = True
        Else
            lblModeStatus.Text = "Idle"
            Exit Sub
        End If

        'Clear counter so app will always start at 0
        'disable this line if you want to see it count 
        'in the other direction after restart.
        ulstat = Daqboard.CLoad(MccCounter, 0)

        tmrEncoderCounter.Enabled = True

    End Sub

    Public Function SelectCounter(ByVal nudCounterNumValue As Int32) As Int32
        Select Case nudCounterNumValue
            Case 0
                MccCounter = MccDaq.CounterRegister.LoadReg0
                MaxLimitRegister = MccDaq.CounterRegister.MaxLimitReg0
            Case 1
                MccCounter = MccDaq.CounterRegister.LoadReg1
                MaxLimitRegister = MccDaq.CounterRegister.MaxLimitReg1
        End Select

        Return MccCounter

    End Function

    Private Sub tmrEncoderCounter_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrEncoderCounter.Tick
        ulstat = Daqboard.CIn32(MccCounter, MyCount)
        lblCounterValueRead.Text = MyCount

    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        tmrEncoderCounter.Enabled = False
        End

    End Sub

    Private Sub chkEnableTimer0_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkEnableTimer0.CheckedChanged
        If chkEnableTimer0.Checked = False Then
            ulstat = Daqboard.PulseOutStop(0)
        Else
            Dim Myfreq As Double = nudTimer0Rate.Value
            Dim MyDutyCycle As Double = 0.5
            ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
        End If
    End Sub

    Private Sub nudTimer0Rate_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudTimer0Rate.ValueChanged
        If (chkEnableTimer0.Checked And btnStartStop.Text = "Stop") Then
            Dim Myfreq As Double = nudTimer0Rate.Value
            Dim MyDutyCycle As Double = 0.5

            ulstat = Daqboard.PulseOutStart(0, Myfreq, MyDutyCycle, 0, 0, 0, MccDaq.PulseOutOptions.Default)
            If ulstat.Value <> MccDaq.ErrorInfo.ErrorCode.NoErrors Then
                errhandler(ulstat)
                Exit Sub
            End If
        End If
    End Sub

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler
        tmrEncoderCounter.Enabled = False
        MessageBox.Show(ulstat.Message, "Universal Library Error ", _
                   MessageBoxButtons.OK, MessageBoxIcon.Error)
        lblModeStatus.Text = "Idle"
        btnStartStop.Text = "Start"
        ulstat = Daqboard.PulseOutStop(0)
    End Sub
End Class
