﻿'The attached Code or Example is provided As Is.  
'It has not been tested or validated as a product, 
'for use in a deployed application or system, or for use in hazardous environments.  
'You assume all risks for use of the Code or Example.
Public Class Form1
    Dim inventory As MccDaq.DaqDeviceDescriptor()
    Public Daqboard As New MccDaq.MccBoard()
    Dim ulstat As MccDaq.ErrorInfo

    Public iTimerNumber As Integer
    Public dFrequency As Double
    Public dDutyCycle As Double
    Public iPulseCount As Integer
    Public dIntialDelay As Double
    Public IdleState As MccDaq.IdleState

    Const AllowedCharactersInt As String = "0123456789"
    Const AllowedCharactersFloat As String = "0123456789."

    Private Sub KeyPressService(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs, ByVal charSet As String)

        If Not charSet.Contains(e.KeyChar) AndAlso e.KeyChar <> ChrW(Keys.Back) Then
            e.Handled = True
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'First,lets make sure there's some kind of 1808 plugged in:
        MccDaq.DaqDeviceManager.IgnoreInstaCal() 'don't use information from InstaCal.

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor 'change cursor to wait.
        Dim Boardfound As Boolean = False

        'load all the boards it can find
        inventory = MccDaq.DaqDeviceManager.GetDaqDeviceInventory(MccDaq.DaqDeviceInterface.Any)
        Dim numDevDiscovered As Integer = inventory.Length 'how many was that?

        If numDevDiscovered > 0 Then
            For boardNum As Integer = 0 To numDevDiscovered - 1

                Try
                    '    Create a new MccBoard object for Board and assign a board number 
                    '    to the specified DAQ device with CreateDaqDevice()
                    Daqboard = MccDaq.DaqDeviceManager.CreateDaqDevice(boardNum, inventory(boardNum))

                    If Daqboard.BoardName.Contains("1808") Then
                        Boardfound = True
                        Daqboard.FlashLED()
                        Exit For
                    Else
                        MccDaq.DaqDeviceManager.ReleaseDaqDevice(Daqboard)
                    End If
                Catch ule As MccDaq.ULException
                    MsgBox(ule.ErrorInfo.Message)
                End Try
            Next
        End If

        If Boardfound = False Then
            MsgBox("No compatible board found in system.", MsgBoxStyle.Critical, "No Board detected")
            End
        End If

        Dim mystring As String = Daqboard.BoardName.Substring(0, Daqboard.BoardName.Trim.Length) + _
                   " found as board number: " + Daqboard.BoardNum.ToString
        Me.Text = mystring

    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        '1 button to start and stop the timer output
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"

            iTimerNumber = nudTimerNumber.Value
            dFrequency = nudFrequency.Value

            Try
                dDutyCycle = Convert.ToDouble(txtDutyCycle.Text)
            Catch ex As Exception
                MsgBox("Invalid value set for Duty Cycle, must be between 0 to 1 uninclusive.", MsgBoxStyle.Critical, "Bad Value.")
                Exit Sub
            End Try
            dDutyCycle = Convert.ToDouble(txtDutyCycle.Text)

            iPulseCount = 0
            dIntialDelay = 0
            IdleState = MccDaq.IdleState.High

            ulstat = Daqboard.PulseOutStart(iTimerNumber, dFrequency, dDutyCycle, iPulseCount, _
                        dIntialDelay, IdleState, MccDaq.PulseOutOptions.Default)
            If ulstat.Value = 0 Then
                lblModeStatus.Text = "Running"
                lblActualFreq.Text = dFrequency.ToString
                lblActualDutyCycle.Text = dDutyCycle.ToString
            Else
                lblModeStatus.Text = "Idle"
                errhandler(ulstat)
                Exit Sub
            End If
        Else

            btnStartStop.Text = "Start"
            ulstat = Daqboard.PulseOutStop(iTimerNumber)
            If ulstat.Value = 0 Then
                lblModeStatus.Text = "Idle"
            Else
                errhandler(ulstat)
                Exit Sub
            End If
        End If

    End Sub

    Public Sub errhandler(ByVal ulstat As MccDaq.ErrorInfo)
        'Generic UL error handler, that gracefully stops the scan 
        'and returns the program to a stable state.
        MessageBox.Show(ulstat.Message, "Universal Library Error ", _
                   MessageBoxButtons.OK, MessageBoxIcon.Error)
        lblModeStatus.Text = "Idle"
        btnStartStop.Text = "Start"

    End Sub

    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        'ends the program.
        ulstat = Daqboard.PulseOutStop(iTimerNumber)
        lblModeStatus.Text = "Idle"
        End
    End Sub

    Private Sub txtDutyCycle_KeyPress(sender As System.Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtDutyCycle.KeyPress
        KeyPressService(sender, e, AllowedCharactersFloat)
    End Sub
End Class
